package nc.lic.toolkit;

import java.security.MessageDigest;
import java.security.Provider;
import java.security.Security;
import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;
import javax.crypto.SecretKey;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.codec.binary.Base64;

public class Encode {

   private static final byte[] keyBytes;


   public static byte[] encode(byte[] dataBytes) throws Exception {
      Cipher cipher = Cipher.getInstance("DESede/ECB/PKCS5Padding", "BC");
      SecretKeySpec key = new SecretKeySpec(keyBytes, "DESede");
      cipher.init(1, key);
      byte[] retrBytes = cipher.doFinal(dataBytes);
      return retrBytes;
   }

   public static byte[] decode(byte[] crypDataBytes) throws Exception {
      Cipher cipher = Cipher.getInstance("DESede/ECB/PKCS5Padding", "BC");
      SecretKeySpec key = new SecretKeySpec(keyBytes, "DESede");
      cipher.init(2, key);
      byte[] retrBytes = cipher.doFinal(crypDataBytes);
      return retrBytes;
   }

   public static byte[] getMsgDigest(byte[] orginData) throws Exception {
      MessageDigest digest = MessageDigest.getInstance("SHA1", "BC");
      digest.update(orginData);
      return digest.digest();
   }

   public static String getBase64MsgDigest(String str) throws Exception {
      if(str == null) {
         return null;
      } else {
         byte[] orignData = str.getBytes("GBK");
         byte[] digestBytes = getMsgDigest(orignData);
         return Base64.encodeBase64String(digestBytes);
      }
   }

   static void createKey() throws Exception {
      KeyGenerator generator = KeyGenerator.getInstance("DESede", "BC");
      generator.init(168);
      SecretKey key = generator.generateKey();
      byte[] keyBytes = key.getEncoded();

      for(int i = 0; i < keyBytes.length; ++i) {
         System.out.print(keyBytes[i]);
      }

      System.out.println();
   }

   public static void main(String ... strings) {
      try {
         String e = "wom我们afdafdsafdsafdsafdsafdsafewfewafds";
         byte[] c = encode(e.getBytes());
         byte[] c2 = decode(c);
         System.out.println(e);
         System.out.println(new String(c2));
      } catch (Exception var4) {
         var4.printStackTrace();
      }

   }

   static {
      if(Security.getProvider("BC") == null) {
         try {
            String e = "org.bouncycastle.jce.provider.BouncyCastleProvider";
            Object o = Class.forName(e).newInstance();
            Security.addProvider((Provider)o);
         } catch (Exception var2) {
            var2.printStackTrace();
         }
      }

      keyBytes = new byte[]{(byte)49, (byte)-70, (byte)11, (byte)-83, (byte)-75, (byte)7, (byte)42, (byte)-123, (byte)-63, (byte)22, (byte)-119, (byte)74, (byte)-71, (byte)98, (byte)-83, (byte)-26, (byte)100, (byte)38, (byte)-116, (byte)124, (byte)-92, (byte)-14, (byte)1, (byte)109};
   }
}
